//------------------------------------------------------------------------------
//
//  npobj.h
//
//  ANTz application based on NPE is free software
//	NPE is the Neural Physics Engine that drives the interactions
//
//	ANTz hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
//	Copyright (c) 2010-2011, Shane Saxon
//	All rights reserved.
//	Redistribution and use in source and binary forms, with or without 
//	modification, are permitted provided that the following conditions are met:
//	-	Redistributions of source code must retain the above copyright notice, 
//		this list of conditions and the following disclaimer.
//	-	Redistributions in binary form must reproduce the above copyright 
//		notice, this list of conditions and the following disclaimer in the 
//		documentation and/or other materials provided with the distribution.
//	-	Neither the name of the Shane Saxon nor the names of its contributors 
//		may be used to endorse or promote products derived from this software 
//		without specific prior written permission.
//	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
//	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
//	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
//	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
//	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
//	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
//	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
//	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
//	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
//	POSSIBILITY OF SUCH DAMAGE.
//
//------------------------------------------------------------------------------

#ifndef NPOBJ_H_
#define NPOBJ_H_


#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitOBJ (void* dataRef);
void npCloseOBJ (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenOBJ (const char* fileName, const char* mode, void* dataRef);

FILE* npOBJNew (const char* fileName, const char* mode, void* dataRef);

FILE* npOBJDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npOBJClose (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadOBJ (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteOBJ (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveOBJ (FILE* file, void* dataRef);

void npImportOBJ (FILE* file, int type, void* dataRef);
void npExportOBJ (FILE* file, void* dataRef);

// file and directory management
void npGetAttribOBJ (int size, void* dataRef);
void npSetAttribOBJ (int size, void* dataRef);

void npTestOBJ (void* fileName, int wordSize, int size, void* dataRef);


#endif